searchNodes=[{"doc":"","ref":"Statux.html","title":"Statux","type":"module"},{"doc":"See Statux.Tracker.child_spec/1 .","ref":"Statux.html#child_spec/1","title":"Statux.child_spec/1","type":"function"},{"doc":"Retrieve the current status for a given ID. iex&gt; Statux . get ( &quot;my_device&quot; ) %{ battery_voltage : % Statux.Models.Status { current : :ok , history : [ :ok , :low ] , transition_count : 2 , transitioned_at : DateTime %{ } } , other_status : % Statux.Models.Status { ... } , ... }","ref":"Statux.html#get/1","title":"Statux.get/1","type":"function"},{"doc":"","ref":"Statux.html#get_for/2","title":"Statux.get_for/2","type":"function"},{"doc":"","ref":"Statux.html#init/1","title":"Statux.init/1","type":"function"},{"doc":"Pass a new value to Statux to be evaluated against the given rule_set Feedback is provided asynchronously, either through the configured PubSub Module or by calling the callbacks given in the rule set. Statux . put ( &quot;my_device&quot; , :battery_voltage , 12.4 )","ref":"Statux.html#put/4","title":"Statux.put/4","type":"function"},{"doc":"","ref":"Statux.html#put_for/5","title":"Statux.put_for/5","type":"function"},{"doc":"Forcefully sets the state of a given id and status to an option. This allows to create options that can not be left automatically, for example a :critical or :warning status that has to be acknowledged manually. iex&gt; Statux . put ( &quot;my_device&quot; , :battery_voltage , :ok ) % Statux.Models.Status { current : :ok , history : [ :ok , :low ] , transition_count : 2 , transitioned_at : DateTime %{ } # now } iex&gt; Statux . put ( &quot;my_device&quot; , :battery_voltage , :some_random_option ) { :error , :invalid_option }","ref":"Statux.html#set/3","title":"Statux.set/3","type":"function"},{"doc":"","ref":"Statux.html#set_for/4","title":"Statux.set_for/4","type":"function"},{"doc":"Using the Status.put/3 function to put a new value Status . put ( id , status_name , value ) you pass in an id. This struct holds the current tracking state for the given id as used by the Status Tracker internally.","ref":"Statux.Models.EntityStatus.html","title":"Statux.Models.EntityStatus","type":"module"},{"doc":"","ref":"Statux.Models.EntityStatus.html#ensure_has_tracking_for_option/4","title":"Statux.Models.EntityStatus.ensure_has_tracking_for_option/4","type":"function"},{"doc":"","ref":"Statux.Models.EntityStatus.html#new_from_rule_set/3","title":"Statux.Models.EntityStatus.new_from_rule_set/3","type":"function"},{"doc":"","ref":"Statux.Models.EntityStatus.html#t:t/0","title":"Statux.Models.EntityStatus.t/0","type":"type"},{"doc":"Represents the current and historic Status","ref":"Statux.Models.Status.html","title":"Statux.Models.Status","type":"module"},{"doc":"","ref":"Statux.Models.Status.html#transition/2","title":"Statux.Models.Status.transition/2","type":"function"},{"doc":"","ref":"Statux.Models.Status.html#transition/3","title":"Statux.Models.Status.transition/3","type":"function"},{"doc":"","ref":"Statux.Models.Status.html#t:t/0","title":"Statux.Models.Status.t/0","type":"type"},{"doc":"The internal state of the Tracker. If you are not planning on significantly changing the library, this is probably not of much interest to you.","ref":"Statux.Models.TrackerState.html","title":"Statux.Models.TrackerState","type":"module"},{"doc":"","ref":"Statux.Models.TrackerState.html#get_rule_set/2","title":"Statux.Models.TrackerState.get_rule_set/2","type":"function"},{"doc":"","ref":"Statux.Models.TrackerState.html#new/3","title":"Statux.Models.TrackerState.new/3","type":"function"},{"doc":"","ref":"Statux.Models.TrackerState.html#set_pubsub/2","title":"Statux.Models.TrackerState.set_pubsub/2","type":"function"},{"doc":"","ref":"Statux.Models.TrackerState.html#set_rule_set/2","title":"Statux.Models.TrackerState.set_rule_set/2","type":"function"},{"doc":"","ref":"Statux.Models.TrackerState.html#set_rule_set/3","title":"Statux.Models.TrackerState.set_rule_set/3","type":"function"},{"doc":"","ref":"Statux.Models.TrackerState.html#t:t/0","title":"Statux.Models.TrackerState.t/0","type":"type"},{"doc":"This Structure holds data that is required to track :count or :duration constraints. It is updated whenever new data comes in and is used to decide wether or not a state can be transitioned into.","ref":"Statux.Models.TrackingData.html","title":"Statux.Models.TrackingData","type":"module"},{"doc":"","ref":"Statux.Models.TrackingData.html#from_option/1","title":"Statux.Models.TrackingData.from_option/1","type":"function"},{"doc":"","ref":"Statux.Models.TrackingData.html#put_invalid/1","title":"Statux.Models.TrackingData.put_invalid/1","type":"function"},{"doc":"","ref":"Statux.Models.TrackingData.html#put_valid/1","title":"Statux.Models.TrackingData.put_valid/1","type":"function"},{"doc":"","ref":"Statux.Models.TrackingData.html#reset/1","title":"Statux.Models.TrackingData.reset/1","type":"function"},{"doc":"","ref":"Statux.Models.TrackingData.html#t:t/0","title":"Statux.Models.TrackingData.t/0","type":"type"},{"doc":"","ref":"Statux.Constraints.html","title":"Statux.Constraints","type":"module"},{"doc":"","ref":"Statux.Constraints.html#check_transition_constraints/4","title":"Statux.Constraints.check_transition_constraints/4","type":"function"},{"doc":"","ref":"Statux.Constraints.html#constraints_fulfilled?/3","title":"Statux.Constraints.constraints_fulfilled?/3","type":"function"},{"doc":"","ref":"Statux.Constraints.html#filter_valid_transition_options/4","title":"Statux.Constraints.filter_valid_transition_options/4","type":"function"},{"doc":"","ref":"Statux.Entities.html","title":"Statux.Entities","type":"module"},{"doc":"","ref":"Statux.Entities.html#update_tracking_data/4","title":"Statux.Entities.update_tracking_data/4","type":"function"},{"doc":"Handles reading configurations from and storing configurations to disk","ref":"Statux.RuleSet.html","title":"Statux.RuleSet","type":"module"},{"doc":"","ref":"Statux.RuleSet.html#from_json!/1","title":"Statux.RuleSet.from_json!/1","type":"function"},{"doc":"","ref":"Statux.RuleSet.html#load_json!/1","title":"Statux.RuleSet.load_json!/1","type":"function"},{"doc":"","ref":"Statux.RuleSet.html#to_json/1","title":"Statux.RuleSet.to_json/1","type":"function"},{"doc":"","ref":"Statux.RuleSet.Parser.html","title":"Statux.RuleSet.Parser","type":"module"},{"doc":"","ref":"Statux.RuleSet.Parser.html#parse!/1","title":"Statux.RuleSet.Parser.parse!/1","type":"function"},{"doc":"","ref":"Statux.RuleSet.Parser.html#serialize!/1","title":"Statux.RuleSet.Parser.serialize!/1","type":"function"},{"doc":"","ref":"Statux.Tracker.html","title":"Statux.Tracker","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Statux.Tracker.html#child_spec/1","title":"Statux.Tracker.child_spec/1","type":"function"},{"doc":"","ref":"Statux.Tracker.html#get/2","title":"Statux.Tracker.get/2","type":"function"},{"doc":"","ref":"Statux.Tracker.html#process_new_data/5","title":"Statux.Tracker.process_new_data/5","type":"function"},{"doc":"","ref":"Statux.Tracker.html#put/5","title":"Statux.Tracker.put/5","type":"function"},{"doc":"","ref":"Statux.Tracker.html#set/4","title":"Statux.Tracker.set/4","type":"function"},{"doc":"","ref":"Statux.Tracker.html#set_status/4","title":"Statux.Tracker.set_status/4","type":"function"},{"doc":"","ref":"Statux.Tracker.html#start_link/1","title":"Statux.Tracker.start_link/1","type":"function"},{"doc":"Handles evaluation and execution of a Transition from one to another or the same status.","ref":"Statux.Transitions.html","title":"Statux.Transitions","type":"module"},{"doc":"Pass in an entity state, a list of options and the name of the status iex&gt; maybe_transition ( entity_state , :battery_voltage , [ :low ] ) updated_entity_state to check constraints for the given status_name and options and, if the constraints are fulfilled, alter the entity_state to the new status. As a side effect, this function may broadcast PubSub messages, if PubSub is configured, and/or trigger the callback functions provided in the rule set for :enter, :stay, :exit (to be implemented) You may use these side effects to react to updates in your application.","ref":"Statux.Transitions.html#transition/4","title":"Statux.Transitions.transition/4","type":"function"},{"doc":"Provides the rules handling for the status system. Expects to get the actual value and the value constraints of states. Returns if the state is valid or not.","ref":"Statux.ValueRules.html","title":"Statux.ValueRules","type":"module"},{"doc":"Takes a set of options and runs through them. Returns the first option that the value rules match for. When the options are nil , what might happen when a set of options is selected that does not exist, an empty list is returned. Example iex&gt; battery_alarm_options = %{ ...&gt; critical : %{ ...&gt; constraints : %{ count : %{ min : 3 } , duration : %{ min : &quot;PT10M&quot; |&gt; Timex.Duration . parse! ( ) } } , ...&gt; value : %{ lt : 11.8 } ...&gt; } , ...&gt; low : %{ ...&gt; constraints : %{ count : %{ min : 3 } , duration : %{ min : &quot;PT10M&quot; |&gt; Timex.Duration . parse! ( ) } } , ...&gt; value : %{ max : 12.0 , min : 11.8 } ...&gt; } , ...&gt; ok : %{ constraints : %{ count : %{ min : 3 } } , value : %{ gt : 12.1 } } ...&gt; } ...&gt; find_possible_valid_status ( 12.6 , battery_alarm_options ) [ :ok ] iex&gt; find_possible_valid_status ( 11.8 , battery_alarm_options ) [ :low ] iex&gt; find_possible_valid_status ( 11.3 , battery_alarm_options ) [ :critical ] iex&gt; find_possible_valid_status ( 11.3 , nil ) [ ]","ref":"Statux.ValueRules.html#find_possible_valid_status/2","title":"Statux.ValueRules.find_possible_valid_status/2","type":"function"},{"doc":"Takes a set of rules and runs through them. Returns the first status that the value rules match for. May be used to check just a subset of validators. Keys that do not exist in the rule set are ignored. Similar to :find_possible_valid_status, but executes the checks in the given order. If your rules are done properly, the order should not matter. However, this can be used to find out conflicts, i.e. when you have rules that overlap and the first rule that matches is taken. Example Both :min and :max include the set value, so the following rule set has a conflict for the value 11.8: iex&gt; rules = %{ ...&gt; overlapping : %{ ...&gt; low : %{ ...&gt; value : %{ max : 11.8 } ...&gt; } , ...&gt; high : %{ ...&gt; value : %{ min : 11.8 } ...&gt; } , ...&gt; } ...&gt; } ...&gt; find_possible_valid_status ( 11.8 , rules . overlapping , [ :low , :high ] ) [ :high , :low ] iex&gt; find_possible_valid_status ( 11.8 , rules . overlapping , [ :high , :low ] ) [ :low , :high ] iex&gt; find_possible_valid_status ( 11.8 , rules . overlapping , [ :not_valid , :low ] ) [ :low ]","ref":"Statux.ValueRules.html#find_possible_valid_status/3","title":"Statux.ValueRules.find_possible_valid_status/3","type":"function"},{"doc":"","ref":"Statux.ValueRules.html#should_be_ignored?/2","title":"Statux.ValueRules.should_be_ignored?/2","type":"function"},{"doc":"Pass in a value and a rule set to check wether the value confirms to the rules or not. Valid rules are: numeric :max , :min , :lt , :gt string :contains , :starts_with , :ends_with , :does_not_contain # TODOL Implement any value :is , :not Example iex&gt; valid? ( 12 , %{ max : 12 } ) true iex&gt; valid? ( 12 , %{ min : 12 } ) true iex&gt; valid? ( 12 , %{ lt : 12 } ) false iex&gt; valid? ( 12 , %{ gt : 12 } ) false iex&gt; valid? ( 11.9 , %{ lt : 12 } ) true iex&gt; valid? ( 12.1 , %{ gt : 12 } ) true iex&gt; valid? ( 11.5 , %{ min : 11.7 , max : 12 } ) false iex&gt; valid? ( 11.7 , %{ is : 11.7 } ) true iex&gt; valid? ( 11.5 , %{ is : 11.7 } ) false iex&gt; valid? ( 11.5 , %{ not : 11.7 } ) true iex&gt; valid? ( 11.7 , %{ not : 11.7 } ) false iex&gt; valid? ( 11.5 , %{ is : [ 11.5 , 11.7 ] } ) true iex&gt; valid? ( 11.6 , %{ is : [ 11.5 , 11.7 ] } ) false iex&gt; valid? ( 11.5 , %{ not : [ 11.5 , 11.7 ] } ) false iex&gt; valid? ( 11.6 , %{ not : [ 11.5 , 11.7 ] } ) true iex&gt; valid? ( 11.6 , %{ max : 12 , min : 10 , not : [ 11.6 ] } ) false iex&gt; valid? ( 11 , %{ max : 12 , min : 10 , not : [ 11.6 ] } ) true iex&gt; valid? ( 9 , %{ max : 12 , min : 10 , not : [ 11.6 ] } ) false iex&gt; valid? ( :no , %{ max : 12 , min : 10 , not : [ :no ] } ) false iex&gt; valid? ( :yes , %{ max : 12 , min : 10 , not : [ :no ] } ) true iex&gt; valid? ( DateTime . utc_now ( ) |&gt; Timex . shift ( minutes : - 10 ) , %{ min : &quot;PT8M&quot; |&gt; Timex.Duration . parse! ( ) } ) true iex&gt; valid? ( DateTime . utc_now ( ) |&gt; Timex . shift ( minutes : - 5 ) , %{ min : &quot;PT8M&quot; |&gt; Timex.Duration . parse! ( ) } ) false iex&gt; valid? ( DateTime . utc_now ( ) |&gt; Timex . shift ( minutes : - 5 ) , %{ max : &quot;PT8M&quot; |&gt; Timex.Duration . parse! ( ) } ) true iex&gt; valid? ( DateTime . utc_now ( ) |&gt; Timex . shift ( minutes : - 10 ) , %{ max : &quot;PT8M&quot; |&gt; Timex.Duration . parse! ( ) } ) false iex&gt; valid? ( DateTime . utc_now ( ) |&gt; Timex . shift ( minutes : - 10 ) , %{ is : &quot;PT10M&quot; |&gt; Timex.Duration . parse! ( ) } ) true iex&gt; valid? ( DateTime . utc_now ( ) |&gt; Timex . shift ( minutes : - 10 ) , %{ not : &quot;PT10M&quot; |&gt; Timex.Duration . parse! ( ) } ) false","ref":"Statux.ValueRules.html#valid?/2","title":"Statux.ValueRules.valid?/2","type":"function"},{"doc":"Statux allows to track the status of entities based on configured constraints. It abstracts all the state handling, you simply pass messages and get notified if a transition happened.","ref":"what_is_statux.html","title":"What is Statux","type":"extras"},{"doc":"Imagine you are controlling your heating/cooling and ventilation with a nerves powered device and some sensors. A simple rule set could look like this: %{ air_quality : %{ # what value do we track? status : %{ # what are possible status for this value? good : %{ value : %{ min : 90 } } , ok : %{ value : %{ min : 70 , lt : 90 } } , # explicitly add lt: 90 as well! bad : %{ value : %{ lt : 70 } } , } } temperature : %{ status : %{ warm : %{ value : %{ gt : 21 } } , good : %{ value : %{ min : 18 , max : 21 } } , cold : %{ value : %{ lt : 18 } } , } } } Now, whenever new sensor data is received, you may pass this data to Statux to compare it to your constraints: Statux . put ( &quot;living_room&quot; , :temperature , 17 ) Statux . put ( &quot;kitchen&quot; , :air_quality , 85 ) Statux will respond to transitions by publishing messages to a pubsub, so you may receive messages like { :exit , :temperature , :good , &quot;living_room&quot; } { :enter , :temperature , :cold , &quot;living_room&quot; } { :stay , :air_quality , :ok , &quot;kitchen&quot; } and could control your heating and ventilation by simply implementing a GenServer handle_info or a Process with a receive loop receive do { :enter , :temperature , :cold , room_id } -&gt; turn_on_heater ( room_id ) { :exit , :temperature , :cold , room_id } -&gt; turn_off_heater ( room_id ) { :enter , :temperature , :warm , room_id } -&gt; turn_on_ac ( room_id ) { :exit , :temperature , :warm , room_id } -&gt; turn_off_ac ( room_id ) { :enter , :air_quality , :bad , room_id } -&gt; turn_on_ventilation ( room_id ) { :enter , :air_quality , :good , room_id } -&gt; turn_off_ventilation ( room_id ) end So far, for the example above, there is no real reason to not just use a bunch of if statements chained together. But when automating heating and ventilation, you may not want to activate or stop those just because someone walked past your sensors and the values changed for a short time. Additional constraints may be given, for example, the number of consecutive messages or a minimum duration for which the :value constraints must be fulfilled. Also, we might want to ignore specific values like nil . Let's change the configuration to require at least 5 consecutive messages to trigger a state change and also a minimum of 1 minute valid state for air quality and 10 minutes for temperature: %{ air_quality : %{ ignore : %{ is : nil } status : %{ good : %{ value : %{ min : 90 } , constraints : { count : %{ min : 5 } , duration : %{ min : &quot;PT1M&quot; } } } ok : %{ value : %{ min : 70 , lt : 90 } , constraints : { count : %{ min : 5 } , duration : %{ min : &quot;PT1M&quot; } } } bad : %{ value : %{ lt : 70 } , constraints : { count : %{ min : 5 } , duration : %{ min : &quot;PT1M&quot; } } } } } temperature : %{ ignore : %{ is : nil } status : %{ warm : %{ value : %{ gt : 21 } , constraints : { count : %{ min : 5 } , duration : %{ min : &quot;PT10M&quot; } } } good : %{ value : %{ min : 18 , max : 21 } , constraints : { count : %{ min : 5 } , duration : %{ min : &quot;PT10M&quot; } } } cold : %{ value : %{ lt : 18 } , constraints : { count : %{ min : 5 } , duration : %{ min : &quot;PT10M&quot; } } } } } } Your implementation remains the same and you can adjust the behaviour through the rules.","ref":"what_is_statux.html#usage-example","title":"What is Statux - Usage Example","type":"extras"},{"doc":"Add Statux to your mix dependencies def deps do [ { :statux , &quot;~&gt; 0.1.0&quot; } , ] end and to your application's Supervisor def start ( _type , _args ) do children = [ # ... { Statux , [ rule_set_file : &quot;rule_set.json&quot; , pubsub : MyApp.PubSub , topic : &quot;my_topic&quot; ] } , # ... ] opts = [ strategy : :one_for_one , name : MyApp.Supervisor ] Supervisor . start_link ( children , opts ) end Note the :rule_set_file . We will get to that in the next chapter.","ref":"installation.html","title":"Installation","type":"extras"},{"doc":"Statux works based on configured rules. If there are no rules, there is nothing to be done.","ref":"getting_started.html","title":"Getting started","type":"extras"},{"doc":"Rule sets describe the logic behind your Status and their transitions. Here is an example rule set as JSON: { &quot;battery_voltage&quot;: { &quot;ignore&quot;: {&quot;value&quot;: {&quot;is&quot;: null}}, &quot;status&quot;: { &quot;good&quot;: {&quot;value&quot;: {&quot;min&quot;: 3.4}}, &quot;bad&quot;: {&quot;value&quot;: {&quot;lt&quot;: 3.4}} }}} JSON was chosen because its easily readable and editable for operations, for example with a textarea and a button in a Phoenix project or as files on disks. Store the JSON file somewhere and either pass it's file path to Statux on startup def start ( _type , _args ) do children = [ { Statux , [ rule_set_file : &quot;rule_set.json&quot; , ... ] } , ] ... or use your projects configuration # application.ex def start ( _type , _args ) do children = [ Statux , ] ... # config file import Config config :statux , rule_set_file : &quot;rule_set.json&quot;","ref":"getting_started.html#define-a-rule-set","title":"Getting started - Define a Rule Set","type":"extras"},{"doc":"When you send data to Statux, it will happily accept them and move on, without any feedback. Data is processed asynchronously, and if something happens that may be of interest to you, Statux will publish this information through Phoenix.PubSub . Add PubSub to your project dependencies and supervision tree. Configure it for Statux. Again, you may choose to set up the PubSub module name and the publishing topic as arguments or through your config file: # application.ex def start ( _type , _args ) do children = [ { Phoenix.PubSub , name : MyPubSub } , { Statux , [ rule_set_file : &quot;rule_set.json&quot; , pubsub : MyPubSub , topic : &quot;Statux&quot; ] } ] ...","ref":"getting_started.html#set-up-notifications","title":"Getting started - Set up notifications","type":"extras"},{"doc":"# Subscribe to updates iex&gt; Phoenix.PubSub . subscribe ( &quot;Statux&quot; ) :ok # Publish a message; wait a bit; flush received messages iex(3)&gt; Statux . put ( &quot;my_device&quot; , :battery_voltage , 3.6 ) ; :timer . sleep ( 100 ) ; flush { :exit , :battery_voltage , nil , &quot;my_device&quot; } { :enter , :battery_voltage , :good , &quot;my_device&quot; } :ok Your Statux is up an running.","ref":"getting_started.html#test-from-iex","title":"Getting started - Test from IEX","type":"extras"},{"doc":"","ref":"options.html","title":"Options for Rule Sets","type":"extras"},{"doc":"A Rule Set has the following structure: Rule Set ├── Status Name 1 │ ├── ignore # optional │ ├── Option 1 │ ├── Option 2 │ └── Option 3 └── Status Name 2 ├── Option A └── Option B The Status Name is your referral or id for tracking and adding values. Example: temperature or battery_voltage . An Option could be something like cold , warm , low , critical . A Status can transition between it's options. If you wish to ignore values, you may set this up as well. If an ignored value is received, it is treated as if it was never received.","ref":"options.html#general-structure","title":"Options for Rule Sets - General Structure","type":"extras"},{"doc":"Available constraints The basic constraints are: min : minimum, including. For numeric values and durations. max : maximum, including. For numeric values and durations. lt : less than. For numeric values and durations. gt : greater than. For numeric values and durations. is : a value or list of values not : a value or list of values contains : a value or string. For lists or strings. (to be implemented) begins_with : a value or string. For lists or strings. (to be implemented) ends_with : a value or string. For lists or strings. (to be implemented) Specific constraints are n_of_m : only for constraints.count . Can not be mixed with other constraints. This allows to set a constraint where n in the last m messages need to fullfil the value constraints. Constraints structure You may define rules for each option to define when a transition to this option should occur. Option ├── value │ └── min, max, is, not, lt, gt, contains, begins_with, ends_with └── constraints ├── duration │ └── min, max, is, not, lt, gt ├── previous_status │ └── is, not └── count └── n_of_m OR min, max, is, not, lt, gt How constraints are evaluated For each Option, the constraints for value are evaluated first. If the check fails, the option is excluded from any further checks. If the value constraints are fulfilled, Statux will update its internal state to remember that the value passed the checks and is considered valid. It will then continue to check the other constraints to see if a transition should happen or is blocked by count , duration or previous_status constraints.","ref":"options.html#defining-constraints-options","title":"Options for Rule Sets - Defining Constraints Options","type":"extras"},{"doc":"Check wether a value is in the range of 10 and 20 for at least 5 consecutive messages: &quot;option&quot; { &quot;value&quot;: {&quot;min&quot;: 10, &quot;max&quot;: 20}, &quot;constraints&quot;: {&quot;count&quot;: {&quot;min&quot;: 5}} } Check wether a value has been in the range of 10 and 20 at least of 3 of 5 messages in the last 10 minutes: &quot;option&quot; { &quot;value&quot;: {&quot;min&quot;: 10, &quot;max&quot;: 20}, &quot;constraints&quot;: {&quot;count&quot;: {&quot;n_of_m&quot;: [3, 5]}, &quot;duration&quot;: {&quot;min&quot;: &quot;PT10M&quot;}} } Durations may be given as ISO8601 Durations or as a numeric value in seconds. The duration is only evaluated when a message is received! It does not automatically transition after a given time. Check for specific values or exclude specific values. Valid only if the value is exactly &quot;hello world&quot; &quot;option&quot; { &quot;value&quot;: {&quot;is&quot;: &quot;hello world&quot;}, } Valid if the value contains &quot;hello&quot; but is not &quot;hello world&quot; or &quot;hello you&quot; . &quot;option&quot; { &quot;value&quot;: {&quot;contains&quot;: &quot;hello&quot;, &quot;not&quot;: [&quot;hello world&quot;, &quot;hello you&quot;]}, }","ref":"options.html#examples-for-constraints","title":"Options for Rule Sets - Examples for Constraints","type":"extras"},{"doc":"Rule Set to track car battery voltages with. { &quot;battery_voltage&quot;: { &quot;ignore&quot;: {&quot;value&quot;: {&quot;is&quot;: null}}, &quot;status&quot;: { &quot;critical&quot;: { &quot;value&quot;: {&quot;lt&quot;: 11.7} &quot;constraints&quot;: { &quot;count&quot;: {&quot;min&quot;: 3}, &quot;duration&quot;: {&quot;min&quot;: &quot;PT10M&quot;} }, }, &quot;low&quot;: { &quot;value&quot;: {&quot;lt&quot;: 12.0, &quot;min&quot;: 11.7} &quot;constraints&quot;: { &quot;count&quot;: {&quot;min&quot;: 3}, &quot;duration&quot;: {&quot;min&quot;: 300}, &quot;previous_status&quot;: {&quot;not&quot;: &quot;critical&quot;} }, }, &quot;ok&quot;: { &quot;value&quot;: {&quot;min&quot;: 12.0} &quot;constraints&quot;: { &quot;count&quot;: {&quot;n_of_m&quot;: [3,5]}, &quot;previous_status&quot;: {&quot;not&quot;: &quot;critical&quot;} }, }}}} Note that the critical state can not be left! It has to be left manually, e.g. by an operator who confirms the issue was resolved and presses a button to force the state to be set to another value. Blocking the exit of critical might not be of most value here, but imagine a machine that stops after a failure and needs repairs. It should not restart operation by itself but require someone to manually start it, to make sure maintenance is completed and there is no person with their hands inside the machine.","ref":"options.html#examples-rule-set","title":"Options for Rule Sets - Examples Rule Set","type":"extras"},{"doc":"Currently, you can not properly set up multiple Rule Sets. To be implemented :) Statux is prepared to use of multiple Rule Sets to allow different configurations for specific devices or customers. The initial Rule Set required to start Statux is automatically set as the :default Rule Set.","ref":"multiple_rule_sets.html","title":"Multiple Rule Sets","type":"extras"}]